///@system  Dstar V10
///@file    DstarTradeApiError.h
///@author  Hao Lin 2021-01-30


#ifndef DSTARTRADEAPIERROR_H
#define DSTARTRADEAPIERROR_H



// 错误码
typedef unsigned int        DstarApiErrorCodeType;
const DstarApiErrorCodeType DSTAR_API_ERR_SUCCESS           = 0;        // 正确
      
const DstarApiErrorCodeType DSTAR_API_ERR_NOCONNECTION      = 10001;    // 未连接
const DstarApiErrorCodeType DSTAR_API_ERR_NOTLOGIN          = 10002;    // 未登录
const DstarApiErrorCodeType DSTAR_API_ERR_NOTREADY          = 10003;    // API未就绪
const DstarApiErrorCodeType DSTAR_API_ERR_SUBSERIALID       = 10004;    // 订阅流号错误
      
const DstarApiErrorCodeType DSTAR_API_ERR_AUTHSTRING        = 20001;    // 认证串错误
const DstarApiErrorCodeType DSTAR_API_ERR_NOACCOUNTNO       = 20002;    // 不存在的账号
const DstarApiErrorCodeType DSTAR_API_ERR_PASSWORD          = 20003;    // 密码错误
const DstarApiErrorCodeType DSTAR_API_ERR_LOGINCOUNT        = 20004;    // 登录数超限
const DstarApiErrorCodeType DSTAR_API_ERR_GWNOTCONN         = 20005;    // 网关未连
const DstarApiErrorCodeType DSTAR_API_ERR_CONTRACTINDEX     = 20006;    // 非法索引值
const DstarApiErrorCodeType DSTAR_API_ERR_TCPLOGIN          = 20007;    // 未进行TCP认证
const DstarApiErrorCodeType DSTAR_API_ERR_ACCOUNTINDEX      = 20008;    // 客户索引值非法
const DstarApiErrorCodeType DSTAR_API_ERR_UDPAUTHCODE       = 20009;    // UDP认证码错误
const DstarApiErrorCodeType DSTAR_API_ERR_NOAUTH            = 20010;    // 未进行UDP认证
const DstarApiErrorCodeType DSTAR_API_ERR_ACCINDEX          = 20011;    // 非认证账号下单
const DstarApiErrorCodeType DSTAR_API_ERR_CONTRACTNO        = 20012;    // 合约索引和合约号不一致
const DstarApiErrorCodeType DSTAR_API_ERR_REQDATA           = 20013;    // 报单字段有误
const DstarApiErrorCodeType DSTAR_API_ERR_CLIENTREQID       = 20014;    // 客户请求号不合法
const DstarApiErrorCodeType DSTAR_API_ERR_ADDRESS           = 20015;    // 报撤单地址异常
const DstarApiErrorCodeType DSTAR_API_ERR_AUTHCODE          = 20016;    // 报撤单认证码异常
const DstarApiErrorCodeType DSTAR_API_ERR_TRADERIGHT        = 20017;    // 没有交易权限
const DstarApiErrorCodeType DSTAR_API_ERR_FUND              = 20018;    // 资金不足
const DstarApiErrorCodeType DSTAR_API_ERR_PARENTFUND        = 20019;    // 父账号资金不足
const DstarApiErrorCodeType DSTAR_API_ERR_ORDERFREQUENCY    = 20020;    // 客户下单频率超限
const DstarApiErrorCodeType DSTAR_API_ERR_AUTHVERSION       = 20021;    // 密钥版本错误
const DstarApiErrorCodeType DSTAR_API_ERR_SUBMITEMPTY       = 20022;    // 信息采集数据为空
const DstarApiErrorCodeType DSTAR_API_ERR_NOLICENSE         = 20023;    // 不存在的授权
const DstarApiErrorCodeType DSTAR_API_ERR_NOORDER           = 20024;    // 撤单未找到原始委托
const DstarApiErrorCodeType DSTAR_API_ERR_SEATINDEX         = 20025;    // 非法席位索引
const DstarApiErrorCodeType DSTAR_API_ERR_MAXCNT            = 20026;    // 批量数量超过单笔最大量
const DstarApiErrorCodeType DSTAR_API_ERR_LICENSENO         = 20027;    // 授权码异常
const DstarApiErrorCodeType DSTAR_API_ERR_VERSION           = 20028;    // 协议版本不一致
const DstarApiErrorCodeType DSTAR_API_ERR_STATE             = 20029;    // 指定委托状态无法撤单
const DstarApiErrorCodeType DSTAR_API_ERR_ENOUGH            = 20030;    // 委托容量不足
const DstarApiErrorCodeType DSTAR_API_ERR_POSITION          = 20031;    // 持仓不足平
const DstarApiErrorCodeType DSTAR_API_ERR_TRADENO           = 20032;    // 不存在交易编码
const DstarApiErrorCodeType DSTAR_API_ERR_SEAT              = 20033;    // 席位异常

const DstarApiErrorCodeType DSTAR_API_ERR_SEATFREQUENCY     = 30001;    // 席位下单频率超限
const DstarApiErrorCodeType DSTAR_API_ERR_SENDFAILED        = 30002;    // 发送失败


//郑商所错误码
// 100:	指定商品状态已成功改变
// 101:	指定商品权限已成功改变
// 102:	指定会员公司状态已成功改变
// 103:	拖定客户状态已成功改变
// 104:	指定交易另状本已成功改变
// 105:	指定交易员已成功释放
// 106:	指定交易员权限已成功改变
// 107:	指定交易员口令已成功改变
// 108:	交易员网络地址已成功改变
// 109:	交易员已成功从交易系统中退出
// 110:	开盘时间已成功改变
// 111:	开市时间已成功改变
// 112:	闭市时间已成功改变
// 113:	结算价计算时间已成功改变
// 114:	交易中断结束时间已成功改变
// 115:	交易中断起始时间已成功改变
// 116:	交易已成功挂起
// 117:	交易已成功释放
// 118:	交易已成功关闭
// 119:	交易已成功开放
// 120:	OK copy interval quotations
// 121:	指定商品停板额已成功改变
// 122:	标题新闻已被成功接受
// 123:	图表查询已成功挂起
// 124:	图表查询已成功开放
// 125:	斩仓单在队列中等待
// 126:	交割申请已被接受
// 127:	Test System
// 129:	交易员口令已成功改变
// 130:	撒销所有委托单成功
// 131:	撒销指定委托单成功
// 132:	交割申请单撤消成功
// 133:	交割申请已成功匹配
// 134:	最大下单量已成功改变
// 135:	最好N个价位值已成功改变
// 136:	交易节已成功改变
// 137:	交易节已成功改变
// 138:	指定会员头寸已成功改变
// 139:	指定商品结算参数已经成功改变
// 140:	操作员指令已经接受
// 141:	最小下单量已经成功改变
// 142:	商品价格波动幅度已经成功改变
// 143:	商品交易节已经成功改变
// 144:	会员最大持仓头寸已经成功改变
// 145:	会员持仓放大因子已经成功改变
// 146:	收会员追加额外保证金成功
// 147:	会员存取结算准备金成功
// 148:	指定会员对该商品的交易权限已成功改变
// 149:	指定管理员命令已经成功撤销
// 150:	指定会员委托单撤销成功
// 151:	交易系统已成功进入协议平仓阶段
// 152:	交易系统已成功退出协议平仓阶段
// 153:	没有找到指定会员委托单
// 154:	内存结算已经成功执行完毕
// 155:	指定商品交割结算价已成功改变
// 156:	会员移仓已经成功执行
// 157:	两个买卖持仓单已经成功对冲完毕
// 158:	指定商品未成交委托单撒销成功
// 159:	商品保证金率已经成功改变
// 160:	指定会员对该商品的参数已成功改变
// 161:	会员减仓单成功	
// 204: 交易员权限不够
// 215:	不可以参与指定品种的交易
// 236:	贵公司持仓已经超过交易所规定最大持仓限制
// 237:	贵公司持仓已经超过交易所规定最大持仓限制
// 251:	现在是协议平仓时间,您的公司不在协议平仓之列
// 252: 目前没有可以响应的做市商
// 254:	没有查询到相应的记录
// 255:	套期保值额度不够
// 256: 目前不支持这样的组合确认方式
// 258:	期权放弃必须在期权最后交易日
// 259: 没有指定的报价请求
// 261:	没有该合约的做市商
// 263:	不是指定合约的做市商
// 264:	报价响应价格中买卖价格错误
// 265:	请求数量超过实际允许数量
// 266:	已经存在指定合约的市场报价（对报价请求）
// 301:	组合定单方式不正确
// 302:	组合定单限制方式不正确
// 303:	没有这样的组合方式
// 304:	SPD组合定单错误
// 305:	IPS组合定单错误
// 306:	BUL组合定单错误
// 307:	BER组合定单错误
// 308:	BLT组合定单错误
// 309:	BRT组合定单错误
// 310:	STD组合定单错误
// 311:	STG组合订单错误
// 312:	限价单价格不能为0或负数
// 313:	止损定单价格不能是可成交的价格
// 314:	市价单价格必须是0
// 315:	系统内存表已满
// 316:	该客户没有在你公司处登记
// 317:	该客户目前不可以进行交易
// 318:	指定的交易品种不进行开盘竞价
// 319:	委托定单限制域不正确
// 320:	定单类型不正确
// 321:	定单有效日期不正确
// 322:	套期保值标志不正确
// 323:	会员没有相应的买卖权限
// 324:	该客户没有相应的买卖权限
// 325:	FOK定单不能立即完全成交
// 326:	该委托单已经完全触发
// 327:	委托单修改定义错误
// 328:	组合定单价格错误
// 329:	委托定单价格超过停板
// 330:	报单请求数超过最大值
// 331:	没有查询到相应的记录
// 332:	止损价与保护价产生矛盾
// 340:	没有该合约的做市商
// 341:	集合竟价期间不允许组合定单
// 342:	不支持期货FOK定单
// 343:	集合意价期间不允许市价单
// 344:	集合竞价期间不允许期货止损单
// 345:	不支持有限制的期货止损单
// 346:	集合竞价期间不允许有限制期权定单
// 347:	集合竞价期间不允许期权市价单
// 348:	不支持期权止损单
// 349:	集合竞价期间不允许期货组合定单
// 350:	不支持期货FOK组合定单
// 351:	不支持期货组合市价单
// 352:	不支持期货组合止损单
// 353:	集合竞价期间不允许期权组合定单
// 354:	不支持无限制期权组合定单
// 355:	不支持期权组合市价单
// 356:	不支持期权组合止损单
// 360: 期权操作类型不正确
// 361:	目前暂不允许IOC定单
// 362:	目前暂不允许FOK市价定单
// 363:	目前暂不允许止损定单
// 364:	目前暂不允许长期有效定单
// 410:	单方无报价时不接受期货组合定单
// 601:	非法系统操作员
// 602:	不是交易时间
// 603:	非法操作员指令
// 604:	非法交易商品代码
// 605:	交易商品状态已处于被改变状态
// 606:	非法交易商品状态
// 607:	会员公司状态已处于被改变状态
// 608:	非法会员公司代码
// 609:	非法会员公司状态
// 610:	非法交易员代码
// 611:	交易员状态已处于被改变状态
// 612:	非法交易员状态
// 613:	非法网络地址
// 614:	交易员已经退出登录
// 615:	非法时间
// 616:	指定时间比开市时间晚
// 617:	指定时间比开市时间早
// 618:	指定时间比闭市时间晚
// 619:	非法中断开始时间
// 620:	结算价计算时间比开市时间早
// 621:	结算价计算时间比闭市时间晚
// 622:	非法中断结束时间
// 623:	中断结束时间必须在中断开始时间之后
// 624:	中断结束时间比开市时间早
// 625:	非法中断开始时间
// 626:	中断开始时间必须在中断结束时间之后
// 627:	中断开始时间比闭市时间晚
// 628:	交易系统已经被暂停
// 629:	交易系统未被暂停
// 630:	交易系统已经被关闭
// 631:	交易系统未被关闭
// 632:	行情表已满(内部错误)
// 633:	统计图表查询已经被暂停
// 634:	统计图表查询已经打开
// 635:	现在不能输入市价委托单
// 636:	委托单价格超过上停板额
// 637:	委托单价格低干下停板额
// 638:	委托单价格不是最小变动价位整数倍
// 639:	委托单表已满(内部错误)
// 640:	非法买卖标志
// 641:	指定商品现在不能进行交易
// 642:	买卖数量不能为零或负数
// 643:	非法开平仓标志
// 644:	请求数量不是整数倍
// 645:	请求合约不是期权
// 646:	平仓数量超过持仓量
// 647:	闭市期权申请只能在最后交易日
// 648:	没有指定查询范围，检查发送协议
// 649:	没有委托定单类型
// 650:	没有新成交单
// 651:	没有新持仓单
// 652:	没有持仓信息
// 653:	没有新行情
// 654:	没有商品行情信息
// 655:	没有新商品信息
// 656:	非法权限
// 657:	非法价格类型(A/B/C)
// 658:	非法日期类型(W/M)
// 659:	非法请求时间
// 660:	没有昨日行情信息
// 661:	没有套期保值额度
// 662:	申清交制品种还没有进入交割
// 663:	非法交割数量
// 665:	持仓表己满(内部错误)
// 666:	现在不是交易时间
// 667:	交易系统已被挂起
// 668:	交易系统协议类型不支持
// 669:	交易系统不能服务所发请求
// 670:	没有访问权限
// 671:	交易员已被挂起
// 672:	你所属会员公司已被挂起
// 673:	非法登录请求
// 674:	非法口令
// 675:	你不能从该工作站登录系统
// 676:	此交易员已经登录
// 677:	旧口令不对
// 678:	该委托单已经成交或已经撒销
// 679:	所撤委托单没有找到
// 680:	指定撤销类型不对
// 681:	非法客户代码
// 682:	所查询的单子没找到
// 683:	成交表已满(内部错误)
// 684:	交割申请表已满(内部错误)
// 685:	不是交割时间
// 687:	交割单没找到
// 688:	没有交割申请单
// 689:	交割单表已满
// 690:	该会员公司持仓超限
// 691:	该会员公司保证金不足
// 692:	该会员公司持仓超限且保证金不足
// 693:	该会员公司不能被斩仓
// 694:	没有图形信息
// 695:	未成交单太多，不能一次传完，请用详细查找范围
// 696:	你不是主所操作员，不能执行该操作
// 697:	该会员不属于你所在的分交易中心，不能执行该操作
// 698:	该交易员不属于你所在的分交易中心，不能执行该操作
// 699:	市价委托单价格错误
// 700:	委托单买卖数量不符合最小变动数量规定
// 701:	用户数量已经超过系统最大限制
// 702:	你不在指定分交易中心且不是主所操作员，不能执行该操作
// 703:	你已经在当前交易节
// 704:	指定交易节已经结束
// 705:	非法交易节号
// 706:	非法最好价位N值
// 707:	指定商品不在本交易节交易
// 708:	买卖数量超过交易所最大下单量限制
// 709:	没有持仓信息
// 710:	该委托单已经撒销
// 711:	该委托单已经成交
// 712:	该委托单为强行平仓单，不可撤销
// 713:	该委托单不是您所下的委托单，不可撒销
// 714:	该商品已转人交割，不能进行交易
// 715:	现在尚未开始交易，不能进行锁单对冲
// 716:	现在已经过了对冲时间，不能进行锁单对冲
// 750:	指定价格超过商品价幅波动上限
// 751:	指定价格超过商品价幅波动下限
// 752:	指定商品现在只可平仓，不可开仓
// 753:	指定商品买方现在只可平仓，不可开仓
// 754:	指定商品卖方现在只可平仓，不可开仓
// 755:	你对指定商品没有交易权限
// 756:	你对指定商品买方现在只可平仓，不可开仓
// 757:	你对指定商品卖方现在只可平仓，不可开仓
// 758:	Cannot Find Clearing Record
// 759:	贵公司缺乏足够资金
// 760:	非法登录版本
// 761:	命令执行时间非法
// 762:	指定管理员命令没找到
// 763:	非法客户代码
// 764:	客户状态已处于被改变状态
// 765:	非法客户状态
// 766:	贵公司持仓己经超过交易所规定最大持仑限制
// 767:	没有交割匹配单
// 768:	没有客户信息
// 769:	没有输人交割仓库
// 770:	非法交割仓库代码
// 771:	没有客户结算信息
// 772:	现在是协议平仓时间，您的公司不在协议平仓之列
// 773:	您在指定品种上买单不能开仓
// 774:	您在指定品种上买单不能平仓
// 775:	您在指定品种上卖单不能开仓
// 776:	您在指定品种上卖单不能平仓
// 777:	指定品种买单不能开仓
// 778:	指定品种买单不能平仓
// 779:	指定品种卖单不能开仓
// 780:	指定品种卖单不能平仓
// 781:	非法连接类型
// 782:	没有交割仓库信息
// 783:	非法交割品种信息
// 784:	现在是协议平仓时间，不能输入交割申请单
// 785:	还没有执行数据装入，不能执行内存结算
// 786:	内存结算已经执行，不能再次执行
// 787:	内存结算出错，查明原因后重新执行或采用数据库结算
// 788:	移仓会员没有足够的持仓量
// 789:	移仓价不在涨跌停板范围内
// 790:	没有相应的保值申请，不能输入保值单
// 791:	委托数量大于相应的保值申请数量
// 792:	非法交易所代码
// 793:	没有查询范围内的信息
// 794:	套期保值平仓数量超过相应持仓量
// 795:	持仓单大多，不能一次传完，请用详细查找范围
// 796:	需对冲的买仓单没有找到
// 797:	需对冲的卖仓单设有找到
// 798:	对冲数量不能为零或负数
// 799:	对冲数量不能大于买卖仓单的最小可平仓量
// 800:	指定两个持仓单不能进行对冲(不符合对冲规定)
// 801:	管理员命令协议错误
// 802:	您不能开仓
// 803:	没有相应的特仓单可供交割
// 804:	只有卖方才可以提交割申请
// 805:	交割数量超过持合单可交割量
// 806:	申请交割数量超过交易所规定最大交割量
// 807:	非法交割品种
// 808:	没有相应交割品种产期
// 809:	仓单中没有相应数量
// 810:	指针表已满(内部错误)
// 811:	所撤交割申请单没有找到
// 812:	您在指定品种上买单不能开仓或平仓
// 813:	您在指定品种上卖单不能开仓或平仓
// 814:	指定品种买单不能开仓或平仓
// 815:	指定品种卖单不能开仓或平仓
// 816:	重试登录次数过多，用户被挂起
// 817:	没有平仓成交单
// 818:	该品种现在还没有闭市，不能修改该参数
// 819:	非法交割品种等级
// 820:	非法交割品种产地
// 821:	没有仓单信息
// 822:	买实数量超过市价单最大下单量限制
// 823:	没有相应委托单
// 824:	该委托单不是您的委托单
// 825:	非法增减标志
// 826:	非法品种类别
// 827:	非法仓单数量
// 828:	该交割单已经撤销
// 829:	你没有相应品种交易权限
// 830:	该品种本月没有交割
// 831:	抵押数量超过空仓持有量
// 832:	今日定单大多，不能一次传完，请用详细查找范围
// 834:	期转现协议平仓合约号有错
// 835:	非法会员公司代码1
// 836:	非法会员公司代码2
// 837:	非法会员公司代码3
// 838:	非法会员公司代码4
// 839:	请检查会员持仓方向
// 840:	集合竞价期间不允许下市价单
// 841:	投资者持仓已经超过交易所规定最大持仓限制
// 900:	会员持仓超限
// 901:	客户持仓超限
// 990:	本功能暂不提供

#endif // DSTARTRADEAPIERROR_H
